// -------------------------------------------------------------------------------
// 
// 		cwCu		ʐMvOwb_t@C
// 
// 				Ver 3.21f
// 
// -------------------------------------------------------------------------------

#ifndef DXARCHIVE_H
#define DXARCHIVE_H

// CN[h -------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxThread.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// cwA[JCu֘A

/*
	o[WƂ̈Ⴂ

	0x0002 DARC_FILEHEAD  PressDataSize ǉ
	0x0004 DARC_HEAD  CharCodeFormat ǉ
	0x0005 ÍꕔύX
	0x0006 64bit
	0x0007 ÍύX( pX[hw肵ꍇ̉Ǔx )
	0x0008 Í̒56bitɕύX


	f[^}bv
		
	DXARC_HEAD
	t@Cf[^
	t@Ce[u
	DXARC_FILEHEAD e[u
	DXARC_DIRECTORY e[u


	t@C̃f[^`
	2byte:̒(oCgTCYS)
	2byte:̃peBf[^(SĂ̒̕l𑫂)
	p͑啶ɕϊꂽt@C̃f[^(S̔{̃TCY)
	p啶ɕϊĂȂt@C̃f[^
*/

#define DXAHEAD							*((WORD *)"DX")		// wb_
#define DXAVER							(0x0008)			// o[W
#define DXAVER_MIN						(0x0008)			// ΉĂŒo[W
#define DXA_KEY_BYTES					(7)					// ̃oCg
#define DXA_KEY_STRING_LENGTH			(63)				// p̒
#define DXA_KEY_STRING_MAXLENGTH		(2048)				// pobt@̃TCY
#define DXA_DIR_MAXARCHIVENUM			(4096)				// ɊJĂA[JCut@C̐
#define DXA_DIR_MAXFILENUM				(32768)				// ɊJĂt@C̐
#define DXA_MAXDRIVENUM					(64)				// ΉhCu̍ő吔
	
// tO
#define DXA_FLAG_NO_KEY					(0x00000001)	// 
#define DXA_FLAG_NO_HEAD_PRESS			(0x00000002)	// wb_̈k

// \̒` --------------------------------------------------------------------

// A[JCuf[^̍ŏ̃wb_
struct DXARC_HEAD
{
	WORD						Head ;							// hc
	WORD						Version ;						// o[W
	DWORD						HeadSize ;						// wb_ DXARC_HEAD 𔲂STCY
	ULONGLONG					DataStartAddress ;				// ŏ̃t@C̃f[^i[Ăf[^AhX(t@C̐擪AhXAhXOƂ)
	ULONGLONG					FileNameTableStartAddress ;		// t@Ce[u̐擪AhX(t@C̐擪AhXAhXOƂ)
	ULONGLONG					FileTableStartAddress ;			// t@Ce[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
	ULONGLONG					DirectoryTableStartAddress ;	// fBNge[u̐擪AhX(oϐ FileNameTableStartAddress ̃AhXOƂ)
																// AhXOzuĂ DXARC_DIRECTORY \̂[gfBNg
	DWORD						CharCodeFormat ;				// t@CɎgpĂR[hy[Wԍ
	DWORD						Flags ;							// tO( DXA_FLAG_NO_KEY  )
	BYTE						HuffmanEncodeKB ;				// t@C̑Õnt}kTCY( PʁFLoCg 0xff ̏ꍇׂ͂Ĉk )
	BYTE						Reserve[ 15 ] ;					// \̈
} ;

// t@C̎ԏ
struct DXARC_FILETIME
{
	ULONGLONG					Create ;						// 쐬
	ULONGLONG					LastAccess ;					// ŏIANZX
	ULONGLONG					LastWrite ;						// ŏIXV
} ;

// t@Cf[^\
struct DXARC_FILENAME
{
	WORD						Length ;						// ̒S
	WORD						Parity ;						// peB
} ;

// t@Ci[
struct DXARC_FILEHEAD
{
	ULONGLONG					NameAddress ;					// t@Ci[ĂAhX( ARCHIVE_HEAD\ ̃oϐ FileNameTableStartAddress ̃AhXAhXOƂ) 
	ULONGLONG					Attributes ;					// t@C
	DXARC_FILETIME				Time ;							// ԏ
	ULONGLONG					DataAddress ;					// t@Ci[ĂAhX
																//			t@C̏ꍇFDXARC_HEAD\ ̃oϐ DataStartAddress AhXAhXOƂ
																//			fBNg̏ꍇFDXARC_HEAD\ ̃oϐ DirectoryTableStartAddress ̂AhXAhXOƂ
	ULONGLONG					DataSize ;						// t@C̃f[^TCY
	ULONGLONG					PressDataSize ;					// k̃f[^̃TCY( 0xffffffff:kĂȂ ) ( Ver0x0002 Œǉꂽ )
	ULONGLONG					HuffPressDataSize ;				// nt}k̃f[^̃TCY( 0xffffffffffffffff:kĂȂ ) ( Ver0x0008 Œǉꂽ )
} ;

// fBNgi[
struct DXARC_DIRECTORY
{
	ULONGLONG					DirectoryAddress ;				//  DXARC_FILEHEAD i[ĂAhX( DXARC_HEAD \ ̃oϐ FileTableStartAddress AhXAhXOƂ)
	ULONGLONG					ParentDirectoryAddress ;		// efBNg DXARC_DIRECTORY i[ĂAhX( DXARC_HEAD\ ̃oϐ DirectoryTableStartAddress AhXAhXOƂ)
	ULONGLONG					FileHeadNum ;					// fBNg̃t@C̐
	ULONGLONG					FileHeadAddress ;				// fBNg̃t@C̃wb_񂪊i[ĂAhX( DXARC_HEAD\ ̃oϐ FileTableStartAddress AhXAhXOƂ) 
} ;



// t@Cpf[^\
struct DXARC_SEARCHDATA
{
	BYTE						FileName[ 1024 ] ;				// t@C
	WORD						Parity ;						// peB
	WORD						PackNum ;						// ̒S
} ;

// e[u\
struct DXARC_TABLE
{
	BYTE						*Top ;							// e[u̐擪|C^
	BYTE						*FileTable ;					// t@Ce[uւ̃|C^
	BYTE						*DirectoryTable ;				// fBNge[uւ̃|C^
	BYTE						*NameTable ;					// Oe[uւ̃|C^
} ;

// A[JCup\
struct DXARC
{
	DXARC_HEAD					Head ;							// A[JCũwb_
	int							CharCodeFormat ;				// R[h`
	DWORD_PTR					ReadAccessOnlyFilePointer ;		// A[JCut@C̃|C^	
	void						*MemoryImage ;					// C[WJꍇ̃AhX
	DXARC_TABLE					Table ;							// ee[uւ̐擪AhXi[ꂽ\
	DXARC_DIRECTORY				*CurrentDirectory ;				// JgfBNgf[^ւ̃|C^

	wchar_t						FilePath[ 1024 ] ;				// t@CpX
	bool						NoKey ;							// sȂǂ
	unsigned char				Key[ DXA_KEY_BYTES ] ;			// 
	char						KeyString[ DXA_KEY_STRING_LENGTH + 1 ] ;	// 
	size_t						KeyStringBytes ;				// ̃oCg
	int							MemoryOpenFlag ;				// ̃t@CJĂ邩AtO
	int							UserMemoryImageFlag ;			// [U[WJC[WgpĂ邩AtO
	LONGLONG					MemoryImageSize ;				// ̃t@CJĂꍇ̃C[W̃TCY
	int							MemoryImageCopyFlag ;			// ̃C[WRs[ĎgpĂ邩ǂ̃tO
	int							MemoryImageReadOnlyFlag ;		// ̃C[Wǂݎpǂ̃tO
	void						*MemoryImageOriginal ;			// ̃C[WRs[ĎgpĂꍇ́ARs[̃f[^i[Ă郁̈

	int							ASyncOpenFlag ;					// 񓯊ǂݍݒtO( TRUE:񓯊ǂݍݒ FALSE:Ⴄ )
	DWORD_PTR					ASyncOpenFilePointer ;			// 񓯊I[vɎgpt@C̃|C^
} ;

// 񓯊ǂݍݏ
#define DXARC_STREAM_ASYNCSTATE_IDLE			(0)				// ĂȂ
#define DXARC_STREAM_ASYNCSTATE_PRESSREAD		(1)				// kꂽt@Cǂݍݒ
#define DXARC_STREAM_ASYNCSTATE_READ			(2)				// f[^ǂݍݒ

// A[JCũt@Cʏ̃t@Cǂݍ݂̂悤ɏׂ̍\
struct DXARC_STREAM
{
	DXARC						*Archive ;						// A[JCuf[^ւ̃|C^
	DXARC_FILEHEAD				*FileHead ;						// t@Cւ̃|C^
	void						*DecodeDataBuffer ;				// 𓀂f[^i[Ă郁̈ւ̃|C^( t@Ckf[^ꍇ̂ݗL )
	void						*DecodeTempBuffer ;				// kf[^ꎞۑp̈ւ̃|C^
	DWORD_PTR					ReadOnlyFilePointer ;			// A[JCut@C̃|C^

	bool						NoKey ;							// sȂǂ
	unsigned char				Key[ DXA_KEY_BYTES ] ;			// 

	int							EOFFlag ;						// EOFtO
	ULONGLONG					FilePoint ;						// t@C|C^
	int							UseASyncReadFlag ;				// 񓯊ǂݍ݃tO
	int							ASyncState ;					// 񓯊ǂݍݏ( DXARC_STREA_ASYNCSTATE n )
	ULONGLONG					ASyncReadFileAddress ;			// 񓯊ǂݍݎ̃t@C|C^

	void						*ReadBuffer ;					// 񓯊ǂݍݎ̈ɓnꂽobt@ւ̃|C^
	LONGLONG					ReadSize ;						// 񓯊ǂݍݎ̈ɓnꂽǂݍ݃TCYւ̃|C^
} ;



// A[JCut@CfBNgɌĂ鏈p̊JĂA[JCut@C̏
struct DXARC_DIR_ARCHIVE
{
	int							UseCounter ;					// ̃A[JCut@CgpĂ鐔
	DXARC						Archive ;						// A[JCut@Cf[^
	wchar_t						Path[ 520 ] ;					// A[JCut@C̃pX
} ;

// A[JCut@CfBNgɌĂ鏈p̊JĂA[JCut@C̃t@C̏
struct DXARC_DIR_FILE
{
	int							UseArchiveFlag ;				// A[JCut@CgpĂ邩tO
	DWORD_PTR					ReadOnlyFilePointer ;			// A[JCugpĂȂꍇ́At@C|C^
	DWORD						UseArchiveIndex ;				// A[JCugpĂꍇAgpĂA[JCut@Cf[^̃CfbNX
	DXARC_STREAM				DXAStream ;						// A[JCut@CgpĂꍇ̃t@CANZXpf[^
} ;

// A[JCufBNgɌĂ鏈p̍\
struct DXARC_DIR
{
	int							InitializeFlag ;				// tO
	DX_CRITICAL_SECTION			CriticalSection ;				// ɃA[JCut@C̃Xg𑀍삵Ȃ悤ɂ邽߂̃NeBJZNV

	int							NotArchivePathCharUp ;			// A[JCupX̉p̏啶ɂȂǂ

	DXARC_DIR_ARCHIVE			*Archive[DXA_DIR_MAXARCHIVENUM] ;	// gpĂA[JCut@C̃f[^
	DXARC_DIR_FILE				*File[DXA_DIR_MAXFILENUM] ;		// JĂt@C̃f[^
	wchar_t						ArchiveExtension[ 64 ] ;		// A[JCut@C̊gq
	int							ArchiveExtensionLength ;		// A[JCut@C̊gq̒
	int							DXAPriority ;					// cwA[JCut@C̗Dx( 1:tH_D 0:DXA[JCuD )

	int							ValidKeyString ;						// KeyString Lǂ
	char						KeyString[ DXA_KEY_STRING_LENGTH + 1 ] ;	// 

	int							ArchiveNum ;					// gpĂA[JCut@C̐
	int							FileNum ;						// JĂt@C̐

	int							BackUseArchiveIndex ;			// OgpA[JCũCfbNX
	wchar_t						BackUseDirectory[ 512 * 3 ] ;	// OgpfBNgpX
	int							BackUseDirectoryPathLength ;	// OgpfBNgpX̒
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 -------------------------------------------------------------

extern DXARC_DIR DX_ArchiveDirData ;

// ֐vg^Cv錾-----------------------------------------------------------

#ifndef DX_NON_DXA

extern	int			DXA_Initialize(					DXARC *DXA ) ;													// A[JCut@Cׂ̍\̂
extern	int			DXA_Terminate(					DXARC *DXA ) ;													// A[JCut@Cׂ̍\̂̌n
extern	int			DXA_OpenArchiveFromFile(		DXARC *DXA, const wchar_t *ArchivePath, const char *KeyString = NULL ) ;							// A[JCut@CJ( 0:  -1:s )
extern	int			DXA_OpenArchiveFromFileUseMem(	DXARC *DXA, const wchar_t *ArchivePath, const char *KeyString = NULL , int ASync = FALSE ) ;		// A[JCut@CJŏɂׂăɓǂݍł珈( 0:  -1:s )
extern	int			DXA_OpenArchiveFromMem(			DXARC *DXA, void *ArchiveImage, int ArchiveSize, int ArchiveImageCopyFlag, int ArchiveImageReadOnlyFlag, const char *KeyString = NULL, const wchar_t *EmulateArchivePath = NULL ) ;				// ɂA[JCut@CC[WJ( 0:  -1:s )
extern	int			DXA_CheckIdle(					DXARC *DXA ) ;													// A[JCut@C𓾂( TRUE:Ă  FALSE:ĂȂ )
extern	int			DXA_CloseArchive(				DXARC *DXA ) ;													// A[JCut@C

//extern int		DXA_LoadFile(					DXARC *DXA, const char *FilePath, void *Buffer, ULONGLONG BufferSize ) ;	// A[JCut@C̎w̃t@Cɓǂݍ( -1:G[ 0ȏ:t@CTCY )
extern	void *		DXA_GetFileImage(				DXARC *DXA ) ;													// A[JCut@Cɓǂݍ񂾏ꍇ̃t@CC[Wi[Ă擪AhX擾( DXA_OpenArchiveFromFileUseMem Ⴕ DXA_OpenArchiveFromMem ŊJꍇɗLAf[^kĂꍇ͒ )
extern	int			DXA_GetFileInfo(				DXARC *DXA, int CharCodeFormat, const char *FilePath, int *Position, int *Size ) ;	// A[JCut@C̎w̃t@C̃t@C̈ʒuƃt@C̑傫𓾂( -1:G[ )
extern	int			DXA_ChangeCurrentDir(			DXARC *DXA, int CharCodeFormat, const char *DirPath ) ;								// A[JCũJgfBNgύX( 0:  -1:s )
//extern int		DXA_GetCurrentDir(				DXARC *DXA, int CharCodeFormat, char *DirPathBuffer, int BufferSize ) ;				// A[JCũJgfBNg擾
extern	DWORD_PTR	DXA_FindFirst(					DXARC *DXA, const BYTE *FilePath, FILEINFOW *Buffer ) ;			// A[JCũIuWFNg( -1:G[ -1ȊO:DXAnh )
extern	int			DXA_FindNext(					DWORD_PTR DxaFindHandle, FILEINFOW *Buffer ) ;					// A[JCũIuWFNg( -1:G[ 0: )
extern	int			DXA_FindClose(					DWORD_PTR DxaFindHandle ) ;										// A[JCũIuWFNgI

extern	int			DXA_STREAM_Initialize(			DXARC_STREAM *DXAStream, DXARC *DXA, const BYTE *FilePath, int UseASyncReadFlag ) ;	// A[JCut@C̃t@CJ
extern	int			DXA_STREAM_Terminate(			DXARC_STREAM *DXAStream ) ;										// A[JCut@C̃t@C
extern	int			DXA_STREAM_Read(				DXARC_STREAM *DXAStream, void *Buffer, size_t ReadLength ) ;	// t@C̓eǂݍ
extern	int			DXA_STREAM_Seek(				DXARC_STREAM *DXAStream, LONGLONG SeekPoint, int SeekMode ) ;	// t@C|C^ύX
extern	LONGLONG	DXA_STREAM_Tell(				DXARC_STREAM *DXAStream ) ;										// ݂̃t@C|C^𓾂
extern	int			DXA_STREAM_Eof(					DXARC_STREAM *DXAStream ) ;										// t@C̏I[ɗĂ邩ÃtO𓾂
extern	int			DXA_STREAM_IdleCheck(			DXARC_STREAM *DXAStream ) ;										// ǂݍݏĂ邩ǂ𒲂ׂ
extern	LONGLONG	DXA_STREAM_Size(				DXARC_STREAM *DXAStream ) ;										// t@C̃TCY擾


extern	int			DXA_DIR_Initialize(				void ) ;														// A[JCufBNgɌĂ鏈̏
extern	int			DXA_DIR_Terminate(				void ) ;														// A[JCufBNgɌĂ鏈̌n
extern	int			DXA_DIR_SetNotArchivePathCharUp( int NotArchivePathCharUpFlag ) ;								// A[JCut@C̃pX啶ɂȂǂ̃tOZbg
extern	int			DXA_DIR_SetArchiveExtension(	const wchar_t *Extension = NULL ) ;								// A[JCut@C̊gqݒ肷
extern	int			DXA_DIR_SetDXArchivePriority(	int Priority = 0 ) ;											// A[JCut@Cƒʏ̃tH_̂ǂ݂ꍇAǂD悳邩ݒ肷( 1:tH_D 0:cwA[JCut@CD(ftHg) )
extern	int			DXA_DIR_SetKeyString(			const char *KeyString = NULL ) ;								// A[JCut@Čݒ肷
extern	LONGLONG	DXA_DIR_LoadFile(				const wchar_t *FilePath, void *Buffer, int BufferSize ) ;			// t@CۂƓǂݍފ֐

extern	DWORD_PTR	DXA_DIR_Open(					const wchar_t *FilePath, int UseCacheFlag = FALSE, int BlockReadFlag = TRUE, int UseASyncReadFlag = FALSE ) ;	// t@CJ( G[F-1  Fnh )
extern	int			DXA_DIR_Close(					DWORD_PTR Handle ) ;											// t@C
extern	LONGLONG	DXA_DIR_Tell(					DWORD_PTR Handle ) ;											// t@C|C^̈ʒu擾
extern	int			DXA_DIR_Seek(					DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;			// t@C|C^̈ʒuύX
extern	size_t		DXA_DIR_Read(					void *Buffer, size_t BlockSize, size_t BlockNum, DWORD_PTR Handle ) ; // t@Cf[^ǂݍ
extern	int			DXA_DIR_Eof(					DWORD_PTR Handle ) ;											// t@C̏I[𒲂ׂ
extern	int			DXA_DIR_IsDXA(					DWORD_PTR Handle ) ;											// ߂l: -1=G[  0=cwA[JCut@C̃t@Cł͂Ȃ  1=cwA[JCut@C̃t@C
extern	int			DXA_DIR_ChDir(					const wchar_t *Path ) ;
extern	int			DXA_DIR_GetDir(					wchar_t *Buffer ) ;
extern	int			DXA_DIR_GetDirS(				wchar_t *Buffer, size_t BufferBytes ) ;
extern	int			DXA_DIR_IdleCheck(				DWORD_PTR Handle ) ;
extern	DWORD_PTR	DXA_DIR_FindFirst(				const wchar_t *FilePath, FILEINFOW *Buffer ) ;					// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			DXA_DIR_FindNext(				DWORD_PTR FindHandle, FILEINFOW *Buffer ) ;						// ߂l: -1=G[  0=
extern	int			DXA_DIR_FindClose(				DWORD_PTR FindHandle ) ;										// ߂l: -1=G[  0=

#endif

extern	int			DXA_Encode(						void *Src, DWORD SrcSize, void *Dest ) ;						// f[^k( ߂l:k̃f[^TCY )
extern	int			DXA_Decode(						void *Src, void *Dest ) ;										// f[^𓀂( ߂l:𓀌̃f[^TCY )

extern	ULONGLONG	Huffman_Encode(					void *Src, ULONGLONG SrcSize, void *Dest ) ;					// f[^nt}k( ߂l:k̃TCY  0 ̓G[  Dest  NULL ƈkf[^i[ɕKvȃTCYԂ )
extern	ULONGLONG	Huffman_Decode(					void *Press, void *Dest ) ;										// nt}kꂽf[^𓀂( ߂l:𓀌̃TCY  0 ̓G[  Dest  NULL Ɖ𓀃f[^i[ɕKvȃTCYԂ )

extern	DWORD		BinToChar128(					void *Src, DWORD SrcSize, void *Dest ) ;						// oCif[^𔼊pɕϊ( ߂l:ϊ̃f[^TCY )
extern	DWORD		Char128ToBin(					void *Src, void *Dest ) ;										// poCif[^ɕϊ( ߂l:ϊ̃f[^TCY )

extern	DWORD		BinToBase64(					void *Src, unsigned int SrcSize, void *Dest ) ;					// oCif[^Base64ɕϊ( ߂l:ϊ̃f[^TCY )
extern	DWORD		Base64ToBin(					void *Src, void *Dest ) ;										// Base64oCif[^ɕϊ( ߂l:ϊ̃f[^TCY )

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DXARCHIVE_H
